aboutsummaryrefslogtreecommitdiff
path: root/format.sh
diff options
context:
space:
mode:
Diffstat (limited to 'format.sh')
-rwxr-xr-xformat.sh46
1 files changed, 36 insertions, 10 deletions
diff --git a/format.sh b/format.sh
index f1440f1b..980c1c70 100755
--- a/format.sh
+++ b/format.sh
@@ -1,14 +1,40 @@
-# C++ & Java
-find -name '*.cpp' -o -name '*.c' -o -name '*.h' -o -name '*.java' | xargs clang-format-13 -i
+#!/usr/bin/env bash
+# Copyright 2023 Code Intelligence GmbH
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
-# Kotlin
-# curl -sSLO https://github.com/pinterest/ktlint/releases/download/0.42.1/ktlint && chmod a+x ktlint
-ktlint -F "agent/**/*.kt" "driver/**/*.kt" "examples/**/*.kt" "sanitizers/**/*.kt" "tests/**/*.kt"
+set -euo pipefail
-# BUILD files
-# go get github.com/bazelbuild/buildtools/buildifier
-buildifier -r .
+THIS_DIR="$(pwd -P)"
# Licence headers
-# go get -u github.com/google/addlicense
-addlicense -c "Code Intelligence GmbH" agent/ bazel/ deploy/ docker/ driver/ examples/ sanitizers/ tests/ *.bzl
+bazel run --config=quiet //:addlicense -- -c "Code Intelligence GmbH" -ignore '**/third_party/**' -ignore '**/.github/**' "$THIS_DIR"
+
+# C++ & Java
+find "$THIS_DIR" \( -name '*.cpp' -o -name '*.c' -o -name '*.h' -o -name '*.java' \) -print0 | xargs -0 bazel run --config=quiet //:clang-format -- -i
+
+# No need to run in CI as these formatters have corresponding Bazel tests.
+if [[ "${CI:-0}" == 0 ]]; then
+ # Kotlin
+ # Check which ktlint_tests failed and run the corresponding fix targets. This is much faster than
+ # running all ktlint_fix targets when e.g. only a few or no .kt files changed.
+ # shellcheck disable=SC2046
+ TARGETS_TO_RUN=$(bazel test --config=quiet $(bazel query --config=quiet 'kind(ktlint_test, //...)') | { grep FAILED || true; } | cut -f1 -d' ' | sed -e 's/:ktlint_test/:ktlint_fix/g')
+ if [[ -n "${TARGETS_TO_RUN}" ]]; then
+ echo "$TARGETS_TO_RUN" | xargs -n 1 bazel run --config=quiet
+ fi
+
+ # BUILD files
+ bazel run --config=quiet //:buildifier -- -r "$THIS_DIR"
+fi